"use strict";

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Flux = exports.mixin = exports.Component = exports.Provider = undefined;
exports.createRenderer = createRenderer;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _events = require("events");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // context

var SharedTypes = {
  emitter: _react2.default.PropTypes.any,
  rootProps: _react2.default.PropTypes.any
};

var Provider = exports.Provider = (function (_React$Component) {
  _inherits(Provider, _React$Component);

  function Provider() {
    _classCallCheck(this, Provider);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Provider).apply(this, arguments));
  }

  _createClass(Provider, [{
    key: "getChildContext",
    value: function getChildContext() {
      return {
        emitter: this.props.emitter,
        rootProps: this.props
      };
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }], [{
    key: "childContextTypes",
    get: function get() {
      return SharedTypes;
    }
  }]);

  return Provider;
})(_react2.default.Component);

var applyMiddlewares = function applyMiddlewares(middlewares, nextState) {
  return middlewares.reduce(function (s, next) {
    return next(s);
  }, nextState);
};

var Component = exports.Component = (function (_React$Component2) {
  _inherits(Component, _React$Component2);

  function Component() {
    _classCallCheck(this, Component);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Component).apply(this, arguments));
  }

  _createClass(Component, [{
    key: "dispatch",
    value: function dispatch() {
      var _context$emitter;

      return (_context$emitter = this.context.emitter).emit.apply(_context$emitter, arguments);
    }
  }], [{
    key: "contextTypes",
    get: function get() {
      return SharedTypes;
    }
  }]);

  return Component;
})(_react2.default.Component);

var mixin = exports.mixin = {
  contextTypes: SharedTypes,
  dispatch: function dispatch() {
    var _context$emitter2;

    return (_context$emitter2 = this.context.emitter).emit.apply(_context$emitter2, arguments);
  }
};

function createRenderer(_ref) {
  var emitter = _ref.emitter;
  var render = _ref.render;

  return function (el) {
    return render(_react2.default.createElement(
      Provider,
      { emitter: emitter },
      el
    ));
  };
}

var Flux = exports.Flux = (function (_EventEmitter) {
  _inherits(Flux, _EventEmitter);

  function Flux(_ref2) {
    var renderer = _ref2.renderer;
    var initialState = _ref2.initialState;
    var middlewares = _ref2.middlewares;

    _classCallCheck(this, Flux);

    var _this3 = _possibleConstructorReturn(this, Object.getPrototypeOf(Flux).call(this));

    _this3.state = initialState ? initialState : {};
    _this3.middlewares = middlewares ? middlewares : [];
    _this3._renderer = createRenderer({ emitter: _this3, render: renderer });
    _this3._renderedElement = null;

    _this3.updating = false;
    _this3._updatingQueues = []; // TODO
    _this3._updatingPromise = null;

    // setup self
    _this3.subscribe();
    return _this3;
  }

  _createClass(Flux, [{
    key: "_finishUpdate",
    value: function _finishUpdate(nextState) {
      var inAsync = !!this._updatingPromise;

      if (inAsync) {
        this._updatingQueues.length = 0;
        this._updatingPromise = null;
        this.updating = false;
      }

      this.state = nextState;
      this._renderedElement = this._renderer(this.render(this.state));

      if (inAsync) {
        this.emit(":end-anync-updating");
      }
      return Promise.resolve();
    }
  }, {
    key: "update",
    value: function update(nextStateFn) {
      var _this4 = this;

      // if app is updating, add fn to queues and return current promise;
      if (this.updating) {
        this._updatingQueues.push(nextStateFn);
        return this._updatingPromise;
      }

      // Create state
      var promiseOrState = applyMiddlewares(this.middlewares, nextStateFn(this.state));

      // if state is not promise, exec and resolve at once.
      if (!(promiseOrState instanceof Promise)) {
        var oldState = this.state;
        this._finishUpdate(promiseOrState);
        this.emit(":process-updating", this.state, oldState);
        return Promise.resolve();
      }

      // start async updating!
      this.updating = true;
      this.emit(":start-async-updating");

      // create callback to response.
      // TODO: I want Promise.defer
      var endUpdate;
      this._updatingPromise = new Promise(function (done) {
        endUpdate = done;
      });

      // drain first async
      var lastState = this.state;
      promiseOrState.then(function (nextState) {
        _this4.emit(":process-async-updating", nextState, lastState);

        // if there is left queue after first async,
        var updateLoop = function updateLoop(appliedState) {
          var nextFn = _this4._updatingQueues.shift();
          if (nextFn == null) {
            _this4._finishUpdate(appliedState);
            endUpdate();
            return;
          } else {
            return Promise.resolve(applyMiddlewares(_this4.middlewares, nextFn(appliedState))).then(function (s) {
              _this4.emit(":process-async-updating", s, appliedState, _this4._updatingQueues.length);
              _this4.emit(":process-updating", s, appliedState);
              updateLoop(s); // recursive loop
            });
          }
        };
        updateLoop(nextState);
      });

      return this._updatingPromise;
    }
  }, {
    key: "_setState",
    value: function _setState() {
      if (this._renderedElement) {
        var _renderedElement;

        (_renderedElement = this._renderedElement).setState.apply(_renderedElement, arguments);
      }
    }
  }, {
    key: "render",
    value: function render(state) {
      // override me
      throw "Override Me";
    }
  }, {
    key: "subscribe",
    value: function subscribe() {
      // override me
    }
  }]);

  return Flux;
})(_events.EventEmitter);